using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Cus_VipInfo
    /// </summary>
    public partial class T_Cus_VipInfo
    {
        public T_Cus_VipInfo()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_ID", "T_Cus_VipInfo");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Cus_VipInfo");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Cus_VipInfo model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Cus_VipInfo(");
            strSql.Append("F_Name,F_Phone,F_Remarks,F_State,F_AddUser,F_AddTime,F_IsDelete,F_UpdateUser,F_UpdateTime,F_DeleteUser,F_DeleteTime)");
            strSql.Append(" values (");
            strSql.Append("@F_Name,@F_Phone,@F_Remarks,@F_State,@F_AddUser,@F_AddTime,@F_IsDelete,@F_UpdateUser,@F_UpdateTime,@F_DeleteUser,@F_DeleteTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Name", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Phone", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Remarks", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_AddUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_AddTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_UpdateUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_UpdateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_DeleteUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DeleteTime", SqlDbType.DateTime)};
            parameters[0].Value = model.F_Name;
            parameters[1].Value = model.F_Phone;
            parameters[2].Value = model.F_Remarks;
            parameters[3].Value = model.F_State;
            parameters[4].Value = model.F_AddUser;
            parameters[5].Value = model.F_AddTime;
            parameters[6].Value = model.F_IsDelete;
            parameters[7].Value = model.F_UpdateUser;
            parameters[8].Value = model.F_UpdateTime;
            parameters[9].Value = model.F_DeleteUser;
            parameters[10].Value = model.F_DeleteTime;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Cus_VipInfo model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Cus_VipInfo set ");
            strSql.Append("F_Name=@F_Name,");
            strSql.Append("F_Phone=@F_Phone,");
            strSql.Append("F_Remarks=@F_Remarks,");
            strSql.Append("F_State=@F_State,");
            strSql.Append("F_AddUser=@F_AddUser,");
            strSql.Append("F_AddTime=@F_AddTime,");
            strSql.Append("F_IsDelete=@F_IsDelete,");
            strSql.Append("F_UpdateUser=@F_UpdateUser,");
            strSql.Append("F_UpdateTime=@F_UpdateTime,");
            strSql.Append("F_DeleteUser=@F_DeleteUser,");
            strSql.Append("F_DeleteTime=@F_DeleteTime");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Name", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Phone", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_Remarks", SqlDbType.NVarChar,-1),
                    new SqlParameter("@F_State", SqlDbType.Int,4),
                    new SqlParameter("@F_AddUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_AddTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_UpdateUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_UpdateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_DeleteUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_DeleteTime", SqlDbType.DateTime),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.F_Name;
            parameters[1].Value = model.F_Phone;
            parameters[2].Value = model.F_Remarks;
            parameters[3].Value = model.F_State;
            parameters[4].Value = model.F_AddUser;
            parameters[5].Value = model.F_AddTime;
            parameters[6].Value = model.F_IsDelete;
            parameters[7].Value = model.F_UpdateUser;
            parameters[8].Value = model.F_UpdateTime;
            parameters[9].Value = model.F_DeleteUser;
            parameters[10].Value = model.F_DeleteTime;
            parameters[11].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Cus_VipInfo ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Cus_VipInfo ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Cus_VipInfo GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,F_Name,F_Phone,F_Remarks,F_State,F_AddUser,F_AddTime,F_IsDelete,F_UpdateUser,F_UpdateTime,F_DeleteUser,F_DeleteTime from T_Cus_VipInfo ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            CallCenterApi.Model.T_Cus_VipInfo model = new CallCenterApi.Model.T_Cus_VipInfo();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Cus_VipInfo DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Cus_VipInfo model = new CallCenterApi.Model.T_Cus_VipInfo();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["F_Name"] != null)
                {
                    model.F_Name = row["F_Name"].ToString();
                }
                if (row["F_Phone"] != null)
                {
                    model.F_Phone = row["F_Phone"].ToString();
                }
                if (row["F_Remarks"] != null)
                {
                    model.F_Remarks = row["F_Remarks"].ToString();
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
                if (row["F_AddUser"] != null)
                {
                    model.F_AddUser = row["F_AddUser"].ToString();
                }
                if (row["F_AddTime"] != null && row["F_AddTime"].ToString() != "")
                {
                    model.F_AddTime = DateTime.Parse(row["F_AddTime"].ToString());
                }
                if (row["F_IsDelete"] != null && row["F_IsDelete"].ToString() != "")
                {
                    model.F_IsDelete = int.Parse(row["F_IsDelete"].ToString());
                }
                if (row["F_UpdateUser"] != null)
                {
                    model.F_UpdateUser = row["F_UpdateUser"].ToString();
                }
                if (row["F_UpdateTime"] != null && row["F_UpdateTime"].ToString() != "")
                {
                    model.F_UpdateTime = DateTime.Parse(row["F_UpdateTime"].ToString());
                }
                if (row["F_DeleteUser"] != null)
                {
                    model.F_DeleteUser = row["F_DeleteUser"].ToString();
                }
                if (row["F_DeleteTime"] != null && row["F_DeleteTime"].ToString() != "")
                {
                    model.F_DeleteTime = DateTime.Parse(row["F_DeleteTime"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,F_Name,F_Phone,F_Remarks,F_State,F_AddUser,F_AddTime,F_IsDelete,F_UpdateUser,F_UpdateTime,F_DeleteUser,F_DeleteTime ");
            strSql.Append(" FROM T_Cus_VipInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ID,F_Name,F_Phone,F_Remarks,F_State,F_AddUser,F_AddTime,F_IsDelete,F_UpdateUser,F_UpdateTime,F_DeleteUser,F_DeleteTime ");
            strSql.Append(" FROM T_Cus_VipInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Cus_VipInfo ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Cus_VipInfo T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Cus_VipInfo";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return CallCenterApi.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
